/*     
 *     d. bodnar  revised 6-16-2016 with Rotary Encoder
 *     http://trainelectronics.com/DCC_Arduino/DCC++/Throttle/
 *     modified msport 17-4-22 for 0.96" 128x64 I2C display library SSD1306Ascii
 *     (c) Locoduino
 *     Aiguillage
 *     Version 0.1a for turnouts one address 0 for throw, 1 for direct
*/
#include "Arduino.h"
#include <Encoder.h>
Encoder knob(3, 2);
#include <Bounce2.h>
Bounce2::Button button = Bounce2::Button();
#define buttonPin 4 
#define ledPin 13      // the number of the LED pin

long encoderPos = -999; 
int voltagePin = A7; // battery voltage

int AddressDble = 2;  
int AddressEncoder = 1; 
#include <Wire.h>
#include "SSD1306Ascii.h"
#include "SSD1306AsciiWire.h"
#define I2C_ADDRESS 0x3C // 0X3C+SA0 - 0x3C or 0x3D
SSD1306AsciiWire oled;

char VERS[] = "0.1a";
float voltage = 3.4;
boolean ledPin_state;

int debug = 0; // set to 1 to show debug info on serial port 

//------------------------------------------------------------------------------
void setup() {
  button.attach( buttonPin, INPUT_PULLUP ); // USE IKTERNAL PULL-UP
  button.interval(5);  // DEBOUNCE INTERVAL IN MILLISECONDS
  int i;
  pinMode(ledPin, OUTPUT);
  pinMode(voltagePin, INPUT);
  Wire.begin();         
  oled.begin(&Adafruit128x64, I2C_ADDRESS);
  oled.set400kHz();
  oled.setFont(ZevvPeep8x16);   
  oled.set2X();
  oled.clear(); 
  Serial.begin (115200);
  Serial.print("Throttle Aiguillages 0.1a");
  Serial.println(" (c) Locoduino");
  button.update();
  oled.println("Aiguille"); 
  delay(2000);
  oled.clear();
  Serial.println("<1>");// power on to DCC++ unit
  oled.setCursor(0, 0);
  oled.set1X();    
  oled.print("VERS ");
  for (int i = 0; i < 4; i++){
   oled.print(VERS[i]);   
  }
  oled.setCursor(0, 2); // start of 2nd line
  oled.println("17-4-22");     
  oled.setCursor(0, 4); // start of 3rd line
  oled.println("(c) Locoduino"); // ©
  oled.print("V = "); // ©
  voltage = 0.01 * analogRead(voltagePin);   
  oled.print(voltage, 1); // battery
  oled.println(" V"); // ©
  oled.set2X();    
  if (debug == 1) Serial.println("");
  delay(5000);  oled.clear();
  encoderPos = -999;
  doMainLCD(); 
  }  // END SETUP

void loop() {
  button.update();
  encoderPos = knob.read();
  if (encoderPos < 0) {knob.write(0);}
  if (encoderPos >256) {knob.write(256);}

  AddressEncoder = encoderPos /4 ;
  AddressDble = encoderPos /2 ;      
  doMainLCD();

  if ( button.fell() ) {
    doDCC();
    oled.setCursor(0, 4); // start of  line
    oled.print("COMMAND");      
    oled.print(" ");
    oled.print(AddressEncoder + 1, DEC); // 
    delay(500);
    doMainLCD();
  }
  digitalWrite(ledPin, ledPin_state);   
}  //END LOOP

void doDCC() {
  if (debug == 1) {
    Serial.println(AddressEncoder);
  }
  digitalWrite(ledPin, LOW);
  Serial.print ("<1>");
  Serial.print ("<a ");
  Serial.print (( (AddressEncoder  ) / 4)  + 1  ); // Accessory Address, DCC++ works with address + sub address
  Serial.print (" ");
  Serial.print ( (AddressEncoder ) % 4 );  // Accessory Sub Address
  if (AddressDble % 2 == 0 ) {      
   Serial.println (" 1 >");
  }
  else {
    Serial.println (" 0 >");
  }
} //END doDCC

void doMainLCD() {
  oled.setCursor(0,0); 
  oled.print("A = ");
  oled.print((AddressDble / 2) + 1 , DEC); 
  oled.println(" "); 
  if ((AddressDble % 2 == 0 )) { 
    oled.print("Devie  ");
    ledPin_state = 1;
  }
  else {
    oled.print("Normal ");
    ledPin_state = 0;
  }
} // end doMainLCD
